const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Automation_jobsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const automation_jobs = await db.automation_jobs.create(
      {
        id: data.id || undefined,

        workflow_name: data.workflow_name || null,
        status: data.status || null,
        runtime_ms: data.runtime_ms || null,
        error_msg: data.error_msg || null,
        started_at: data.started_at || null,
        finished_at: data.finished_at || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await automation_jobs.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await automation_jobs.setOrganizations(data.organizations || null, {
      transaction,
    });

    return automation_jobs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const automation_jobsData = data.map((item, index) => ({
      id: item.id || undefined,

      workflow_name: item.workflow_name || null,
      status: item.status || null,
      runtime_ms: item.runtime_ms || null,
      error_msg: item.error_msg || null,
      started_at: item.started_at || null,
      finished_at: item.finished_at || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const automation_jobs = await db.automation_jobs.bulkCreate(
      automation_jobsData,
      { transaction },
    );

    // For each item created, replace relation files

    return automation_jobs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const automation_jobs = await db.automation_jobs.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.workflow_name !== undefined)
      updatePayload.workflow_name = data.workflow_name;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.runtime_ms !== undefined)
      updatePayload.runtime_ms = data.runtime_ms;

    if (data.error_msg !== undefined) updatePayload.error_msg = data.error_msg;

    if (data.started_at !== undefined)
      updatePayload.started_at = data.started_at;

    if (data.finished_at !== undefined)
      updatePayload.finished_at = data.finished_at;

    updatePayload.updatedById = currentUser.id;

    await automation_jobs.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await automation_jobs.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await automation_jobs.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return automation_jobs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const automation_jobs = await db.automation_jobs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of automation_jobs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of automation_jobs) {
        await record.destroy({ transaction });
      }
    });

    return automation_jobs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const automation_jobs = await db.automation_jobs.findByPk(id, options);

    await automation_jobs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await automation_jobs.destroy({
      transaction,
    });

    return automation_jobs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const automation_jobs = await db.automation_jobs.findOne(
      { where },
      { transaction },
    );

    if (!automation_jobs) {
      return automation_jobs;
    }

    const output = automation_jobs.get({ plain: true });

    output.organization = await automation_jobs.getOrganization({
      transaction,
    });

    output.organizations = await automation_jobs.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.workflow_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'automation_jobs',
            'workflow_name',
            filter.workflow_name,
          ),
        };
      }

      if (filter.error_msg) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'automation_jobs',
            'error_msg',
            filter.error_msg,
          ),
        };
      }

      if (filter.runtime_msRange) {
        const [start, end] = filter.runtime_msRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            runtime_ms: {
              ...where.runtime_ms,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            runtime_ms: {
              ...where.runtime_ms,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.started_atRange) {
        const [start, end] = filter.started_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            started_at: {
              ...where.started_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            started_at: {
              ...where.started_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.finished_atRange) {
        const [start, end] = filter.finished_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            finished_at: {
              ...where.finished_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            finished_at: {
              ...where.finished_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.automation_jobs.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('automation_jobs', 'workflow_name', query),
        ],
      };
    }

    const records = await db.automation_jobs.findAll({
      attributes: ['id', 'workflow_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['workflow_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.workflow_name,
    }));
  }
};
